/*
 * SPDX-FileCopyrightText: NVIDIA CORPORATION & AFFILIATES
 * Copyright (c) 2023-2025 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 * SPDX-License-Identifier: LicenseRef-NvidiaProprietary
 *
 * NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
 * property and proprietary rights in and to this material, related
 * documentation and any modifications thereto. Any use, reproduction,
 * disclosure or distribution of this material and related documentation
 * without an express license agreement from NVIDIA CORPORATION or
 * its affiliates is strictly prohibited.
 */

#ifndef DOCA_MIRROR_H
#define DOCA_MIRROR_H

#define DOCA_MIRRORS_MAX_TARGETS 2

struct doca_flow_port;
struct doca_mirror_ctx;
struct doca_mirrors;
struct doca_offload_esw_ctx;

struct doca_mirrors *
doca_mirrors_create(struct doca_offload_esw_ctx *esw, struct doca_flow_port *esw_port,
                    uint32_t esw_id);
void
doca_mirrors_destroy(struct doca_mirrors *doca_mirrors);

struct doca_mirror_ctx *
doca_mirror_ctx_ref(struct doca_mirrors *doca_mirrors,
                    struct doca_flow_resource_mirror_cfg *cfg);
void
doca_mirror_ctx_unref(struct doca_mirror_ctx *mirror_ctx);
doca_error_t
doca_mirror_ctx_bind(struct doca_mirror_ctx *mirror_ctx, void *bindable_object,
                     uint32_t *shared_mirror_id);
void
doca_mirrors_bindable_object_released(void *bindable_object);

#endif /* DOCA_MIRROR_H */
